#library(urbanR)
#library(RNetCDF)
library(sp)
library(sf)
#library(mapview)
#library(ncdf4)
library(rgeos) 
library(ggplot2)
library(plyr) #OJO! la llibreria plyr ha de ser cridada abans que dplyr 
library(dplyr) 
#library(broom)
#library(magrittr)
library(ggpubr)
library(raster)
#library(rgdal)
#library(tmap)
library(gstat)
library(sp)
library(abind)
library(openair)
library(tidyr)
#library(RColorBrewer)
#library(Metrics)
#library(gbm)
#library(lubridate)
#library(matrixStats)


pollutants       <- c("pm2p5")
years            <- c(2019) 


general_path <- "/esarchive/scratch/abarrant/results_regional_"
save_sp      <- "/esarchive/scratch/abarrant/results_regional_2019/results_gene_pm2p5/stats_results/"


compute_in_UTM   <- "TRUE"
crs_latlon       <- "+proj=longlat +datum=WGS84 +ellps=WGS84 +towgs84=0,0,0"
crs_utm          <- "+proj=utm +zone=31 +ellps=intl +units=m +no_defs"


#my_box            <- rgeos::bbox2SP(43.02355,40.24870,3.497162,-0.001190186, proj4string = CRS(crs_latlon)) # lat màx, lat min, lon max, lon min
my_box            <- rgeos::bbox2SP(43.0,40.25,3.485,0.01, proj4string = CRS(crs_latlon)) # lat màx, lat min, lon max, lon min
if (compute_in_UTM) {
  my_box <- spTransform(my_box, sp::CRS(crs_utm))
}
# Generate an uniform mesh
receptor_grid                     <- sf::st_sf(geom=sf::st_make_grid(my_box, n=c(60,60), what = "centers"), crs=crs_latlon)
sp_receptor_grid                  <- sf::as_Spatial(receptor_grid)
sp::proj4string(sp_receptor_grid) <- crs_utm

#rang <- c(0,10,20,30,40,80,120,160,200,300,400)
rang <-c(0, 10, 20,30,35,40,45,50,60,70,80,90)
rang_annual <- c(0, 5, 20, 25, 90)
filesname <- "UK_gene_pm2p5"     #uk
#filesname <- "UK_gene_pm2p5_gbm" #uk gbm


p<- 1
pollutant     <- pollutants[p]
save_final_sp <- paste0(save_sp,pollutant,"_matrix")


y <- 1
year            <- years[y]

pollutant_path  <- paste0(general_path,year,"/results_gene_",pollutant, "/output")
path_model      <- paste0(pollutant_path,"/df_annual_uk.rds")            #ja estic agafant la mitjana
#path_model      <- paste0(pollutant_path,"/model_gene_",pollutant,".rds")  
path_coords     <- paste0(pollutant_path,"/coords_model_gene_",pollutant,".rds")

coords_model    <- readRDS(file = path_coords)

lon_model       <- coords_model[, "lon_model"]
lat_model       <- coords_model[, "lat_model"]
#model_corrected <- readRDS(file=path_model)
df_annual_mean  <- readRDS(file=path_model)


file_list <- list.files(pollutant_path, pattern = paste0(filesname,"_\\d{8}\\.rds$"), full.names = TRUE)
#file_list <- file_list[1:2]

#save the values from each file
data_list <- lapply(file_list, function(file_path) {
  data <- readRDS(file_path)
  return(data[[1]]) 
})

#convert into a dataframe (rows are points, cols are days)
data_matrix <- do.call(cbind, data_list)

#mean of each point, row mean over all days
#mean_vector <- rowMeans(data_matrix, na.rm = TRUE)

#guardem les dades amb la mateixa estructura q els rds dentrada
#result_mean_df <- data_list[[1]]  #estructura
#result_mean_df <- mean_vector

#Annual mean
annual_mean                      <- rowMeans(data_matrix, na.rm = TRUE)
df_annual_mean                   <- data.frame(pollutant=annual_mean, lon=lon_model, lat=lat_model)
coordinates(df_annual_mean)      <- ~lon+lat
sp::proj4string(df_annual_mean)  <- crs_latlon

if (compute_in_UTM) {
  df_annual_mean <- spTransform(df_annual_mean, sp::CRS(crs_utm))
}

set.seed(1) #we are picking random points in the next line, set.seed permits us to have same points in each loop
df_annual_mean     <- na.omit(df_annual_mean)
pick_random_points <- sample(1:nrow(df_annual_mean),20000)
pollutant.fit_ok   <- automap::autofitVariogram(formula=pollutant~1, input_data=df_annual_mean[pick_random_points,],model="Ste")
#pollutant.fit_ok   <- automap::autofitVariogram(formula=pollutant~1, input_data=df_annual_mean,model="Ste")
ok_gstat           <- gstat(formula=pollutant~1, data = df_annual_mean, model = pollutant.fit_ok$var_model, nmax=25)
OK                 <- predict(object=ok_gstat, newdata=sp_receptor_grid)

#saveRDS(object=OK, file=paste0(general_path,"OK_UK_sp.rds"))

pixels      <- sp::SpatialPixelsDataFrame(OK, as.data.frame(OK[,"var1.pred"]))
#pixels      <- sp::SpatialPixelsDataFrame(OK,tolerance = 0.99, as.data.frame(OK@data$var1.pred))
mean_raster <- raster::raster(pixels[,'var1.pred'])

#writeOGR(mean_raster, dsn = paste0(save_final_sp,"/annual_mean_",pollutant, "_",year,".shp"), layer = "capa", driver = "ESRI Shapefile")
#datos_leidos <- readOGR(dsn = paste0(save_final_sp,"/annual_mean_",pollutant, "_",year,".shp"), layer = paste0("annual_mean_pm2p5_2019"))

# mapview::mapview(OK$var1.pred, at=rang)
# mapview::mapview(datos_leidos, at=rang)
#mapview::mapview(mean_raster, at=rang)
mapview::mapview(pixels, zcol="var1.pred", at=rang_annual)
#mapview::mapview(pixels, zcol="var1.pred", at=rang)
